/*
	parser.c

	original code: SASANO Takayoshi
	--- public domain, no warranty.
*/

#include "common.h"

LOCAL	W	VOBJpos;

/* $B%H%l!<%l%3!<%I$N9=C[(B */
LOCAL	W	build_tray(TRAYREC *tray, W id, W len, VP dt, UW attr)
{
	W	n;

	switch (id) {
	case	TR_TEXT:
	case	TS_TEXT:
	case	TS_TEXTEND:
	case	TS_FIG:
	case	TS_FIGEND:
	case	TS_IMAGE:
	case	TS_DFUSEN:
	case	TS_FFUSEN:
	case	TS_SFUSEN:

	case	TS_TPAGE:
	case	TS_TRULER:
	case	TS_TFONT:
	case	TS_TCHAR:
	case	TS_TATTR:
	case	TS_TSTYLE:
	case	TS_TVAR:
	case	TS_TMEMO:
	case	TS_TAPPL:

	case	TS_FPRIM:
	case	TS_FDEF:
	case	TS_FGRP:
	case	TS_FMAC:
	case	TS_FATTR:
	case	TS_FPAGE:
	case	TS_FMEMO:
	case	TS_FAPPL:
		/* $B=PNO(B */
		n = 1;
	break;

	case	TS_VOBJ:
		/* $B2>?H%l%3!<%I$N:n@.(B */
		if (VOBJpos < VOBJentry) {	
			/* XXX $B2>?H%;%0%a%s%H$N$_%3%T!<$9$k(B
			   XXX $B!J8GM-%G!<%?$O0z$-7Q$2$J$$!K(B */
			VOBJdata[VOBJpos].vseg = *(VOBJSEG *)dt;
			VOBJdata[VOBJpos].vseg.dlen = 0;

			id = TR_VOBJ;
			len = sizeof(TR_VOBJREC);
			dt = (B *)&VOBJdata[VOBJpos++];

			n = 1;
		} else {
			/* $BBP1~$9$k2>?H$,B8:_$7$J$$!JIT@5$J>uBV!K(B */
			n = 0;
		}
		break;

	case	TS_INFO:
	default:
		/* $BGK4~(B */
		n = 0;
		break;
	}

	if (tray == NULL) {
		DP(("id:%02x len:%08x dt:%08x [%d]\n", id, len, dt, n));
	} else if (n) {
		tray->id = id;
		tray->len = len;
		tray->dt = dt;
	}

	return n;
}

/* $BHs%;%0%a%s%HItJ,$ND9$5$r5a$a$k(B */
LOCAL	W	nonseg_length(UH *buf, W size)
{
	W	i;

	for (i = 0; i < size; i++) {
		if (*buf++ >= 0xff00) break;
	}

	return i * sizeof(UH);	// TAD$B%G!<%?$KJo$$!"La$jCM$O(Bbyte$BC10L$H$9$k(B
}

/* TAD$B%G!<%?$r%;%0%a%s%HC10L$K%Q!<%9(B */
EXPORT	W	parse(TRAYREC *tray, UH *buf, W size, UW attr)
{
	W	i, n, pos, len;
	UH	id;
	TRAYREC	*t;

	VOBJpos = 0;
	size /= 2;

	i = n = 0;
	while (i < size) {
		id = buf[pos = i];
		t = (tray == NULL) ? NULL : &tray[n];

		/* TAD$BJ8;zNs(B */
		if (id < 0xff00) {
			len = nonseg_length(&buf[pos], size - pos);
			n += build_tray(t, TR_TEXT, len, &buf[pos], attr);
			i += len / 2;
			continue;
		}

		/* TAD$B%;%0%a%s%H(B */
		//       (normal)	(large)
		// pos+0 ID		ID
		// pos+1 length		0xffff
		// pos+2		length(low)
		// pos+3		length(high)

		/* ID$B$H(Blength$B$,FI$_=P$;$k$3$H(B */
		if (pos + 2 > size) break;
		len = buf[pos + 1];

		/* $B%i!<%8%;%0%a%s%H$N>l9g(B */
		if (len == 0xffff) {
			pos += 2;
			i += 2;
			if (pos + 2 > size) break;
			len = (buf[pos + 1] << 16) | buf[pos + 0];
		}

		/* $B%;%0%a%s%HK\BN$rA4$FFI$_=P$;$k$3$H(B */
		if (pos + 2 + len / 2 > size) break;
		n += build_tray(t, id & 0xff, len, &buf[pos + 2], attr);
		i += 2 + len / 2;
	}

	return n;
}
